#!/usr/bin/python3
#coding=utf-8
import re
from bluepy import btle
from bluepy.btle import Scanner, DefaultDelegate
import time
import sys
import datetime

macexp = re.compile(r'^60:C0:BF')

class ScanDelegate(DefaultDelegate):
    def __init__(self):
        DefaultDelegate.__init__(self)

    def handleDiscovery(self, dev, isNewDev, isNewData):
        if isNewDev:
            print("Discovered device", dev.addr, dev.getValueText(9))
        elif isNewData:
            print("Received new data from", dev.addr)

sensor_json = {}
for k in 'Humidity,Temperature,Pressure,Light,Microphone,Airquality'.split(','):
    sensor_json[k] = 0
for t in 'Accelerometer,Gyroscope,Magnetometer'.split(','):
    sensor_json[t] = "0,0,0"
    sensor_json[t + 'X'] = sensor_json[t + 'Y'] = sensor_json[t + 'Z'] = 0
for z in 'Version'.split(','):
    sensor_json[z] = 0
    sensor_json['software' + z] = sensor_json['firmware' + z] = 0


def num(s):
    f = float(s)
    if f.is_integer():
        return int(f)
    else:
        return f

def scan(timeout=5):
    scanner = Scanner().withDelegate(ScanDelegate())
    devices = scanner.scan(timeout)

    result = []
    for dev in devices:
        #print("Device %s (%s), RSSI=%d dB" % (dev.addr, dev.addrType, dev.rssi))
        for (adtype, desc, value) in dev.getScanData():
            print("%s, %s = %s" % (adtype, desc, value))
        result.append({"name": dev.getValueText(9), "mac": dev.addr})

    return result








class MyDelegate(btle.DefaultDelegate):
    def __init__(self):
        btle.DefaultDelegate.__init__(self)
        # ... initialise here

    def handleNotification(self, cHandle, data):
        print('handleNotification: {}'.format(str(data)))
        global sensor_json
        global k
        global t
        global z
        i = 0
        get_val = data[:1].decode()
        print("get_val {}".format(get_val))
        k = False
        if get_val == "7":
            k = 'Humidity'
        elif get_val == "6":
            k = 'Temperature'
        elif get_val == "5":
            k = 'Pressure'
        elif get_val == "9":
            k = 'Light'
        elif get_val == "3":
            k = 'Microphone'
        elif get_val == "4":
            k = 'Airquality'
        elif get_val == "G":
            t = 'Gyroscope'
        elif get_val == "M":
            t = 'Magnetometer'
        elif get_val == "A":
            t = 'Accelerometer'
        elif get_val == "R":
            z = "Version"
        else :
            i = 1

        if k and i == 0:
            try:
                print("k {}".format(k))
                sensor_json[k] = num(data[4:].decode())
            except:
                print("An exception occurred")
        elif t and i == 0:
            print("t {}".format(t))
            sensor_json[t] = data[2:].decode()
            try:
                (sensor_json[t + 'X'], sensor_json[t + 'Y'], sensor_json[t + 'Z']) = map(num, sensor_json[t].split(','))
            except:
                print("An exception occurred")

        elif z and i == 0:
            print("z {}".format(z))
            sensor_json[z] = data[4:].decode()
            try:
                (sensor_json["software:"+z], sensor_json["firmware:"+z]) = map(num, data[z].split(','))
            except:
                print("An exception occurred")

        if(i == 0):
            print(sensor_json)
            print("time:", datetime.datetime.now())
        # outfile.close()


global mac
global device
global is_write_data_to_sensor

try:

    print("""

   _____            _       _            _       _       _   
  / ____|          (_)     | |          | |     (_)     | |  
 | |  __  ___ _ __  _  __ _| |_ ___  ___| |__    _  ___ | |_ 
 | | |_ |/ _ \ '_ \| |/ _` | __/ _ \/ __| '_ \  | |/ _ \| __|
 | |__| |  __/ | | | | (_| | ||  __/ (__| | | | | | (_) | |_ 
  \_____|\___|_| |_|_|\__,_|\__\___|\___|_| |_| |_|\___/ \__|
                                                             
                                                             

    """)
    is_write_data_to_sensor = False
    mac = False
    device = False
    while not mac:
        result = scan()
        for d in result:
            print("-----------------name",d["name"],"mac",d["mac"])
            if macexp.match(d['mac'].upper()):
                mac = d['mac']
                print("----------------------------mac",mac)
                break

    for i in range(5):
        try:
            print("//////////////////////////////////////////////////////////////////////////////////////////")
            print("//////////////////////////////////////  connecting  ", datetime.datetime.now(),
                  "//////////////////////////////////////")
            print("//////////////////////////////////////////////////////////////////////////////////////////")
            device = btle.Peripheral(mac)
            break
        except Exception as e:
            print("//////////////////////////////////////////////////////////////////////////////////////////")
            print("///////////////////////  Connection failed, try to reconnect",e,"////////////////////////////")
            print("//////////////////////////////////////////////////////////////////////////////////////////")

    if not device:
        print("------------ device is not connect failed -----------")
        sys.exit("giving up")


    #print("----------------- open notify ---------------------")

    time.sleep(2)
    service_uuid = btle.UUID('e093f3b5-00a3-a9e5-9eca-40016e0edc24')
    noti_uuid = btle.UUID('e093f3b6-00a3-a9e5-9eca-40026e0edc24')


    svc = device.getServiceByUUID(service_uuid)
    notify = svc.getCharacteristics()[0]
    write = svc.getCharacteristics()[1]

    device.setDelegate(MyDelegate())
    noti_handle = notify.getHandle() + 1

    time.sleep(1.0)

    while True:
        i = 1
        if device.waitForNotifications(1.0):
            # if i == 1:
            # handleNotification() was called
            # dev.waitForNotifications(1.0)
            # svc = dev.getServiceByUUID(service_uuid)
            # write = svc.getCharacteristics()[1]
            if(is_write_data_to_sensor):
                write_handle = write.getHandle()
                device.writeCharacteristic(write_handle, b"5/EV/P")
                device.writeCharacteristic(write_handle, b"6/EV/T")
                device.writeCharacteristic(write_handle, b"7/EV/H")
                device.writeCharacteristic(write_handle, b"9/AL/L")
                device.writeCharacteristic(write_handle, b"4/EV/A")
                device.writeCharacteristic(write_handle, b"3/ON/N")
                # dev.writeCharacteristic(write_handle, b"G/AO/AR")
                # dev.writeCharacteristic(write_handle, b"M/AO/M")
                # dev.writeCharacteristic(write_handle, b"A/AD/A")
                # dev.setDelegate(MyDelegate())
                time.sleep(1.0)

            # read = svc.getCharacteristics()[0]
            # read_handle = read.getHandle()
            # s = dev.readCharacteristic(read_handle)
            # print(s)
            # time.sleep(1)
        #else:
            #print("else")

except Exception as e:
    print("error",e)
finally:
    print("finally")
